
{ Screen- und Musekram ------------------- }

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

procedure register;
begin
  { Register all the drivers }
  if RegisterBGIdriver(@CGADriverProc) < 0 then
    Abort('CGA');
  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA/VGA');
  if RegisterBGIdriver(@HercDriverProc) < 0 then
    Abort('Herc');
  if RegisterBGIdriver(@ATTDriverProc) < 0 then
    Abort('AT&T');
  if RegisterBGIdriver(@PC3270DriverProc) < 0 then
    Abort('PC 3270');
  { Register all the fonts }
  if RegisterBGIfont(@GothicFontProc) < 0 then
    Abort('Gothic');
  if RegisterBGIfont(@SansSerifFontProc) < 0 then
    Abort('SansSerif');
  if RegisterBGIfont(@SmallFontProc) < 0 then
    Abort('Small');
  if RegisterBGIfont(@TriplexFontProc) < 0 then
    Abort('Triplex');
end;


procedure initscr(var ok:boolean);
var i,j,k,graphdriver,graphmode,errcode:integer;
    r,g,b                          :word;
begin
   register;
   graphdriver:=detect;
   initgraph(graphdriver,graphmode,'');
   ok:=(graphresult=0) and (graphdriver=9);
   { EGA-Farben, aber schattiert! : }
   SetRGBPalette(0,$00,$00,$00);
   SetRGBPalette(1,$00,$00,$20);
   SetRGBPalette(2,$30,$28,$00);
   SetRGBPalette(3,$00,$20,$28);
   SetRGBPalette(4,$2c,$00,$10);
   SetRGBPalette(5,$28,$00,$28);
   SetRGBPalette(6,$38,$14,$10);
   SetRGBPalette(7,$30,$2a,$28);
   SetRGBPalette(8,$14,$1a,$20);
   SetRGBPalette(9,$14,$14,$3c);
   SetRGBPalette(10,$14,$3c,$14);
   SetRGBPalette(11,$14,$3c,$3c);
   SetRGBPalette(12,$3c,$18,$14);
   SetRGBPalette(13,$3c,$14,$3c);
   SetRGBPalette(14,$3c,$3c,$14);
   SetRGBPalette(15,$3c,$3c,$3c);
   for i:=0 to 15 do setpalette(i,i);
end;


procedure initimages;
const hex='0123456789ABCDEF ';
var t        :array[0..9] of string;
    i,j,k,c  :integer;
    size     :longint;
    bufptr   :integer;

   procedure getthem(var ima:image; var size:longint; ct:integer);
   var i,j,k,c:integer;
       temp   :string;
   begin
   with ima do begin
      k:=24;
      for i:=1 to 4 do begin
         temp:=t[i];
         for j:=1 to length(temp) do begin
            c:=pred(pos(temp[j],hex));
            putpixel(23+j,k,c);
         end;
         inc(k);
      end;
      for i:=1 to 8 do begin
         temp:=t[5];
         for j:=1 to length(temp) do begin
            c:=pred(pos(temp[j],hex));
            putpixel(23+j,k,c);
         end;
         inc(k);
      end;
      for i:=1 to 4 do begin
         temp:=t[5+i];
         for j:=1 to length(temp) do begin
            c:=pred(pos(temp[j],hex));
            putpixel(23+j,k,c);
         end;
         inc(k);
      end;

      if ct in [8..11] then case ct of
      8: begin
         SetColor(15);
         outtextxy(29,29,'#');    { Block }
         end;
      9: begin
         SetColor(10);
         outtextxy(29,29,'*');    { Bonus }
         end;
     10: begin
         SetColor(15);
         outtextxy(30,30,'@');    { Bombe }
         SetColor(13);
         outtextxy(29,29,'@');    { Bombe }
         end;
     11: begin
         SetColor(10);
         outtextxy(30,30,'x');    { Tilt }
         SetColor(15);
         outtextxy(28,28,'@');    { Tilt }
         SetColor(12);
         outtextxy(29,29,'*');    { Tilt }
         end;
      end;

      p_data:=addr(ibuff[bufptr]);
      p_nextimage:=nil;
      x:=0;
      y:=0;
      GetImage(24,24,width+24,height+24,p_data^);
      size:=ImageSize(24,24,width+24,height+24);
   end;
   end;


procedure getexplo(var ima:image; var size:longint);
var i,j,k,x,y:integer; temp:string;
begin
   k:=24;
   for i:=1 to 8 do begin
      temp:=t[i];
      for j:=1 to length(temp) do begin
         c:=pred(pos(temp[j],hex));
         putpixel(23+j,k,c);
         putpixel(40-j,40-i,c);
      end;
      inc(k);
   end;
   with ima do begin
      p_data:=addr(ibuff[bufptr]);
      p_nextimage:=nil;
      x:=0;
      y:=0;
      GetImage(24,24,width+24,height+24,p_data^);
      size:=ImageSize(24,24,width+24,height+24);
   end;
end;


begin
bufptr:=0;
with ima[1] do begin
   width:=16;
   height:=16;
   t[1]:='FFFFFFFFFFFFFFFF';
   t[2]:='FFFFFFFFFFFFFFF0';
   t[3]:='FFAAAAAAAAAAAA80';
   t[4]:='FFAAAAAAAAAAA880';
   t[5]:='FFAA222222222880';
   t[6]:='FFAA222222222880';
   t[7]:='FFA8888888888880';
   t[8]:='F888888888888880';
   t[9]:='0000000000000000';
end;
getthem(ima[1],size,1);

bufptr:=bufptr+size;
with ima[2] do begin
   width:=16;
   height:=16;
   t[3]:='FFBBBBBBBBBBBB80';
   t[4]:='FFBBBBBBBBBBB880';
   t[5]:='FFBB333333333880';
   t[6]:='FFBB333333333880';
   t[7]:='FFB8888888888880';
end;
getthem(ima[2],size,2);

bufptr:=bufptr+size;
with ima[3] do begin
   width:=16;
   height:=16;
   t[3]:='FFCCCCCCCCCCCC80';
   t[4]:='FFCCCCCCCCCCC880';
   t[5]:='FFCC444444444880';
   t[6]:='FFCC444444444880';
   t[7]:='FFC8888888888880';
end;
getthem(ima[3],size,3);

bufptr:=bufptr+size;
with ima[4] do begin
   width:=16;
   height:=16;
   t[3]:='FFDDDDDDDDDDDD80';
   t[4]:='FFDDDDDDDDDDD880';
   t[5]:='FFDD555555555880';
   t[6]:='FFDD555555555880';
   t[7]:='FFD8888888888880';

end;
getthem(ima[4],size,4);
bufptr:=bufptr+size;
with ima[5] do begin
   width:=16;
   height:=16;
   t[3]:='FF99999999999980';
   t[4]:='FF99999999999880';
   t[5]:='FF99111111111880';
   t[6]:='FF99111111111880';
   t[7]:='FF98888888888880';
end;
getthem(ima[5],size,5);

bufptr:=bufptr+size;
with ima[6] do begin
   width:=16;
   height:=16;
   t[3]:='FFEEEEEEEEEEEE80';
   t[4]:='FFEEEEEEEEEEE880';
   t[5]:='FFEE666666666880';
   t[6]:='FFEE666666666880';
   t[7]:='FFE8888888888880';
end;
getthem(ima[6],size,6);


bufptr:=bufptr+size;
with ima[7] do begin
   width:=16;
   height:=16;
   t[3]:='FFEEEEEEEEEEEE80';
   t[4]:='FFEEEEEEEEEEE880';
   t[5]:='FFEE000000000880';
   t[6]:='FFEE000000000880';
   t[7]:='FFE8888888888880';
end;
getthem(ima[7],size,7);

bufptr:=bufptr+size;
with ima[8] do begin
   width:=16;
   height:=16;
end;
getthem(ima[8],size,8);

bufptr:=bufptr+size;
with ima[9] do begin
   width:=16;
   height:=16;
end;
getthem(ima[9],size,9);

bufptr:=bufptr+size;
with ima[10] do begin
   width:=16;
   height:=16;
end;
getthem(ima[10],size,10);

bufptr:=bufptr+size;
with ima[11] do begin
   width:=16;
   height:=16;
end;
getthem(ima[11],size,11);
bufptr:=bufptr+size;
with ima[12] do begin
   width:=16;
   height:=16;
   t[1]:='8888888888888888';
   t[2]:='8888888888888880';
   t[3]:='8877777777777780';
   t[4]:='8877777777777880';
   t[5]:='8877888888888880';
   t[6]:='8877888888888880';
   t[7]:='8878888888888880';
   t[8]:='8888888888888880';
   t[9]:='0000000000000000';
end;
getthem(ima[12],size,12);
bufptr:=bufptr+size;

with ima[13] do begin
width:=16; height:=16;
t[1]:='0000000000000000';
t[2]:='0000000000000000';
t[3]:='00C00A0C00C0A0C0';
t[4]:='000C0A0C00C0AC00';
t[5]:='0000C0A0C0CAC000';
t[6]:='00A00CABCC0C00A0';
t[7]:='000AA0BBBCCAAA00';
t[8]:='00000AABBBA00000';
getexplo(ima[13],size);
bufptr:=bufptr+size;
end;

with ima[14] do begin
width:=16; height:=16;
t[1]:='0000000000000000';
t[2]:='0000000000000000';
t[3]:='0000000000000000';
t[4]:='0000000000000000';
t[5]:='00000A0A0A0A0000';
t[6]:='0000000CA000A0A0';
t[7]:='0000A00C0BBC0000';
t[8]:='00A000A0ACBB0C00';
getexplo(ima[14],size);
bufptr:=bufptr+size;
end;

end;

