procedure initsteine;
var i,j,k:integer;
begin
for i:=0 to 7 do with stein[i] do begin
   x:=0;
   y:=0;
   for j:=0 to 3 do for k:=0 to 3 do mark[j,k]:=0;
end;
with stein[1] do for i:=0 to 3 do mark[i,0]:=1;
for i:=2 to 4 do with stein[i] do begin
   for j:=0 to 2 do mark[j,0]:=i;
   mark[i-2,1]:=i;
end;
for i:=5 to 6 do with stein[i] do begin
   for j:=0 to 1 do begin
      mark[j,0]:=i;
      mark[j+i-5,1]:=i;
   end;
end;
with stein[7] do begin
   mark[1,0]:=7; mark[2,0]:=7; mark[0,1]:=7; mark[1,1]:=7
end;
end;

procedure loeschestein(stein:chip);
var i,j,k,x1,y1,x2,y2:integer;
begin
with stein do for i:=0 to 3 do for j:=0 to 3 do if mark[i,j]>0 then begin
   x1:=(x+i)*dx+ox;
   y1:=(y+j)*dy+oy;
   x2:=x1+pred(dx);
   y2:=y1+pred(dy);
   rectfill(x1,y1,x2,y2,8);
end;
end;

procedure zeichnestein(stein:chip);
var i,j,k,x1,y1:integer;
begin
with stein do for i:=0 to 3 do for j:=0 to 3 do begin
    k:=mark[i,j];
    if k in [1..12] then begin
      x1:=(i+x)*dx+ox;
      y1:=(j+y)*dy+oy;
      p_hilf:=addr(ima[k]);
      drawimage(x1,y1,p_hilf);
   end;
end;
end;


procedure sprenge(stein:chip);
var i,j,k,x1,y1:integer;
begin
with stein do begin
   for i:=0 to 3 do for j:=0 to 3 do if mark[i,j]>0 then begin
      x1:=(i+x)*dx+ox;
      y1:=(j+y)*dy+oy;
      p_hilf:=addr(ima[13]);
      drawimage(x1,y1,p_hilf);
   end;
   delay(200);
   for i:=0 to 3 do for j:=0 to 3 do if mark[i,j]>0 then begin
      x1:=(i+x)*dx+ox;
      y1:=(j+y)*dy+oy;
      p_hilf:=addr(ima[14]);
      drawimage(x1,y1,p_hilf);
   end;
   delay(100);

   for i:=0 to 3 do for j:=0 to 3 do if mark[i,j]>0 then begin
      x1:=(i+x)*dx+ox;
      y1:=(j+y)*dy+oy;
      rectfill(x1,y1,x1+pred(dx),y1+pred(dy),8);
      rectfill(x1+4,y1+4,x1+pred(dx)-4,y1+pred(dy)-4,0);
   end;
   delay(100);

   for i:=0 to 3 do for j:=0 to 3 do if mark[i,j]>0 then begin
      x1:=(i+x)*dx+ox;
      y1:=(j+y)*dy+oy;
      rectfill(x1,y1,x1+pred(dx),y1+pred(dy),8);
      rectfill(x1+6,y1+6,x1+pred(dx)-6,y1+pred(dy)-6,0);
   end;
   delay(100);
end;

loeschestein(stein);
end;




procedure ausrichten(var stein:chip);
var i,j,k:integer;
begin
with stein do repeat { nach oben }
   k:=0;
   for i:=0 to 3 do k:=k+mark[i,0];
   if k=0 then begin
      for j:=0 to 2 do for i:=0 to 3 do mark[i,j]:=mark[i,succ(j)];
      for i:=0 to 3 do mark[i,3]:=0;
   end;
until k>0;
with stein do repeat { nach links }
   k:=0;
   for i:=0 to 3 do k:=k+mark[0,i];
   if k=0 then begin
      for j:=0 to 2 do for i:=0 to 3 do mark[j,i]:=mark[succ(j),i];
      for i:=0 to 3 do mark[3,i]:=0;
   end;
until k>0;
end;

function haengt(stein:chip):integer;
var i,j,k,l:integer;
begin
   k:=0;
   l:=0;
   with stein do for i:=0 to 3 do for j:=0 to 3 do
   if mark[i,j]>0 then if f[x+i,y+j]>0 then begin
      k:=f[x+i,j+y];
      if k=12 then k:=8;
      if (l>0) then begin
         if k<l then l:=k;
      end else l:=k;
   end;
   haengt:=l;
end;

procedure fixieren(stein:chip);
var i,j,k:integer;
begin
   with stein do for i:=0 to 3 do for j:=0 to 3 do
   if mark[i,j]>0 then f[x+i,j+y]:=mark[i,j];
end;


function voll(stein:chip):boolean;
begin
   voll:= (stein.y=0) and (haengt(stein)>0);
end;


procedure drop(var stein:chip; var haenger:integer);
var i,j:integer;
begin
   inc(stein.y);
   haenger:=haengt(stein);
   dec(stein.y);
   if haenger=0 then begin
      loeschestein(stein);
      inc(stein.y);
      zeichnestein(stein);
   end;
end;


procedure dropsaeule(x,y:integer);
var stopit:boolean;
    i     :integer;
begin
   stopit:=false;
   i:=y;
   while (i>0) and (not stopit) do begin
      case f[x,pred(i)] of
      0..7,9: f[x,i]:=f[x,pred(i)];
    8,10..12: begin
                 stopit:=true;
                  f[x,i]:=0;
              end;
      end;
      dec(i);
   end;
end;


procedure checkreihe(var p:longint);
var i,j,k:integer; flag:boolean;
begin
repeat
   flag:=false;
   for i:=1 to pred(ymax) do begin
      k:=0;
      for j:=1 to pred(xmax) do if f[j,i]>0 then inc(k);
      if k=pred(xmax) then begin
         for j:=1 to pred(xmax) do begin
            if f[j,i]=9 then p:=p+500;
            if f[j,i]<>8 then dropsaeule(j,i) else flag:=true;
         end;
         p:=p+100*nchip;
         for k:=0 to i do for j:=1 to pred(xmax) do 
         if f[j,k]=0 then
         rectfill(j*dx+ox,k*dy+oy,j*dx+ox+pred(dx),k*dy+oy+pred(dy),8)
         else begin
            p_hilf:=addr(ima[f[j,k]]);
            drawimage(j*dx+ox,k*dy+oy,p_hilf);
         end;
      end;
   end;
 until not flag;
end;
 

procedure left(var stein:chip; var i:integer);
begin
   with stein do if (x>1) then begin
      dec(x);
      i:=haengt(stein);
      inc(x);
      if i=0 then begin
         loeschestein(stein);
         dec(x);
         zeichnestein(stein);
      end;
   end;
end;

 
procedure right(var stein:chip; var i:integer);
begin
   with stein do if x<pred(xmax) then begin
      inc(x);
      i:=haengt(stein);
      dec(x);
      if i=0 then begin
         loeschestein(stein);
         inc(x);
         zeichnestein(stein);
      end;
   end;
end;


procedure turn(var stein:chip; var k:integer);
var i,j:integer;
    neu:chip;
begin
   neu:=stein;
   for i:=0 to 3 do for j:=0 to 3 do neu.mark[3-i,j]:=stein.mark[j,i];
   ausrichten(neu);
   i:=haengt(neu);
   if i>0 then if stein.x<pred(xmax) then begin
      neu.x:=stein.x+1; i:=haengt(neu);
   end;
   if i>0 then if stein.x>1 then begin
      neu.x:=stein.x-1; i:=haengt(neu);
   end;
   if i>0 then if stein.x<(xmax-2) then begin
      neu.x:=stein.x+2; i:=haengt(neu);
   end;
   if i>0 then if stein.x>2 then begin
      neu.x:=stein.x-2; i:=haengt(neu);
   end;
   if i>0 then if stein.x<(xmax-3) then begin
      neu.x:=stein.x+3; i:=haengt(neu);
   end;
   if i>0 then if stein.x>3 then begin
      neu.x:=stein.x-3; i:=haengt(neu);
   end;

   if i=0 then begin
      loeschestein(stein);
      zeichnestein(neu);
      stein:=neu
   end;
end;


procedure flip(var stein:chip; var k:integer);
var i,j:integer;
    neu:chip;
begin
   neu:=stein;
   for i:=0 to 3 do for j:=0 to 3 do neu.mark[i,j]:=stein.mark[3-i,j];
   ausrichten(neu);
   i:=haengt(neu);
   if i>0 then begin neu.x:=stein.x+1; i:=haengt(neu); end;
   if i>0 then begin neu.x:=stein.x-1; i:=haengt(neu); end;
   if i>0 then begin neu.x:=stein.x+2; i:=haengt(neu); end;
   if i>0 then begin neu.x:=stein.x-2; i:=haengt(neu); end;
   if i=0 then begin loeschestein(stein); zeichnestein(neu); stein:=neu end;
end;
