program Tetrix;
{ UJA Version 1.00         15.05.94 }
{     1. spielbare Version: 13.05.94 }
{     HiScore, Chipanzeige, Level 1 - 7  : 15.05.94 }
{ UJA Version 1.01:  Schikanen a la Amiga: 16.05.94 }
{ UJA Version 1.02:  kleine Beschleunigung fr meinen SysOpa: 14.08.94 }

uses crt,dos,graph,BGIdriv,BGIFont,drivers;

const dx=16; dy=16; xmax=11; ymax=21;
      ox=192; oy=64; oyy=48; oxx=48;

type feld   =array[0..xmax+3,0..ymax] of integer;
     imabuff=array[0..6000] of byte;

{$i \inc\intu1.inc}

type chip=record
          x,y :integer;
          mark:array[0..3,0..3] of integer;
          end;

     hiscore=record
          namen:string;
          score:longint;
          end;

var
    ima                        :array[1..15] of image;
    p_hilf                     :pointer;
    ibuff:imabuff;

    stein                            :array[0..7] of chip;
    hsc                              :array[0..11] of hiscore;
    h,nextchip,i,j,level,grmod       :integer;
    punkte                           :longint;
    ok,fertig,ende,anzeige           :boolean;
    f                                :feld;
    speed,speeda,count,nchip,speed0  :integer;
    ch                               :char;
    lnamen                           :string;


{$i tetrix2.inc } { graphinit, images erstellen }
{$i tetrix3.inc } { Steine  - Subroutinen }
{$i tetrix4.inc } { Screen  - Darstellung }
{$i tetrix5.inc } { HiScore - Routinen }
{$i tetrix6.inc } { Level   - Routinen }


procedure auswerten;
var i,j,k:integer; ch1:char;
begin
   while keypressed do begin
      ch1:=readkey;
      if ch1=#0 then begin
         i:=0;
         ch1:=readkey;
         case ch1 of
         #72: turn(stein[0],i);
         #75: left(stein[0],i);
         #77: right(stein[0],i);
         #80: speed:=0;
         else;
         end;
         if i>9 then h:=i;
      end else begin
         ch1:=upcase(ch1);
         case ch1 of
         #27: ende:=true;
         '-': if level>0 then begin
              level:=level-2;
              nchip:=40;
              h:=1;
           end;

      '+': begin
              nchip:=40;
              h:=1;
           end;
      #65: begin
              anzeige:=not anzeige;
              if anzeige then begin
                 stein[nextchip].x:=-8;
                 stein[nextchip].y:=1;
                 zeichnestein(stein[nextchip]);
              end else rectfill(oxx+dx,oy+dy,oxx+5*dx,oy+4*dy,8)
           end;

      #70: flip(stein[0],i);     {f}
      #79: fertig:=true;
      #80: begin                 {p}
              repeat delay(50) until keypressed;
              ch1:=readkey;
           end;                  {r}
      #82: begin
              textmode(3);
              setgraphmode(grmod);
              screenzeichnen;
              showhighscore;
              for i:=1 to pred(xmax) do for j:=0 to pred(ymax) do
              if f[i,j]>0 then begin
                 p_hilf:=addr(ima[f[i,j]]);
                 drawimage(i*dx+ox,j*dy+oy,p_hilf);
              end;
              updatlevel(level,'Na? Screen vermanscht?');
           end;
      else ; 
      end;
   end;
  end;
end;



procedure initgame;
var j,k:integer;
begin
   punkte:=0;
   updatscore(punkte);
   level:=0;
   updatlevel(level,'Easy does it!');
   count:=0;
   nchip:=0;
   i:=0;
   for k:=1 to pred(xmax) do for j:=0 to pred(ymax) do f[k,j]:=0;
   rectfill(ox+dx,oy,ox+xmax*dx,oy+ymax*dy,8);
   ende:=false;
   fertig:=false;
end;



begin
speed0:=5;
if paramcount>0 then begin
   val(paramstr(1),speed0,i);
   if speed0<1 then speed0:=5;
   if speed0>99 then speed0:=50;
end;

initscr(ok);
loadhiscore;
if ok then begin
   grmod:=getgraphmode;
   RectFill(0,0,639,479,8);
   initimages;
   screenzeichnen;
   showhighscore;
   initsteine;
   ima[15]:=ima[8];
   ima[8]:=ima[12];
   for i:=0 to xmax do f[i,ymax]:=12;
   for i:=0 to ymax do begin
      f[0,i]:=12;
      f[xmax,i]:=12;
   end;

   anzeige:=true;
   initgame;
   i:=succ(random(7) mod 7);
   repeat
      speed:=64-nchip;
      count:=0;
      stein[0]:=stein[i];
      randomize; i:=succ(random(7) mod 7);
      nextchip:=i;
      if anzeige then begin
         stein[nextchip].x:=-8;
         stein[nextchip].y:=1;
         rectfill(oxx+dx,oy+dy,oxx+5*dx,oy+4*dy,8);
         zeichnestein(stein[nextchip]);
      end;
      stein[0].y:=0;
      stein[0].x:=succ(random(7));
      fertig:=voll(stein[0]);

      if not fertig then begin
         h:=0;
         repeat
            inc(count);
            if count>speed then begin
               drop(stein[0],h);
               count:=0;
            end;
            delay(speed0*5); auswerten;
         until (h>0) or ende;

         if h=10 then sprenge(stein[0]) else fixieren(stein[0]);
         fertig:=fertig or (h=11);
         checkreihe(punkte);
         inc(nchip);
         if nchip>=40 then begin
            nchip:=0;
            punkte:=punkte+100;
            inc(level);
            ladelevel(level,lnamen,f);
            updatlevel(level,lnamen);
         end;
         if h<>10 then punkte:=punkte+2*nchip;
         updatscore(punkte);
         delay(100);
      end;

      if fertig then begin
         fanfare;
         updathiscore(punkte);
         repeat delay(50) until keypressed;
         ch:=readkey;
         ende:=(ch=#27);
         if not ende then initgame;
      end;

   until ende or fertig;

end;
textmode(3);
end.

